Package jebl.evolution.trees

# Class ClusteringTreeBuilder<T extends Tree>

java.lang.Object
jebl.evolution.trees.ClusteringTreeBuilder<T>

All Implemented Interfaces:
  `TreeBuilder<T>`

Direct Known Subclasses:
  `NeighborJoiningTreeBuilder`

public abstract class ClusteringTreeBuilder<T extends Tree> extends Object implements TreeBuilder<T>
An abstract base class for clustering algorithms from pairwise distances

Version:
  $Id: ClusteringTreeBuilder.java 662 2007-03-21 00:32:24Z twobeers $
Author:
  Andrew Rambaut, Alexei Drummond, Joseph Heled Adapted from Alexei Drummond BEAST code.

## Method Summary

Modifier and Type
Method
Description
`void`
`addProgressListener(ProgressListener listener)`
`T`
`build()`
`void`
`fireSetProgress(double fractionCompleted)`
`static ClusteringTreeBuilder`
`getBuilder(TreeBuilderFactory.Method method, DistanceMatrix distances)`
A factory method to create a ClusteringTreeBuilder
`void`
`removeProgressListener(ProgressListener listener)`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Method Details

### build

public T build()

Specified by:
  `build` in interface `TreeBuilder<T extends Tree>`

### addProgressListener

public void addProgressListener(ProgressListener listener)

Specified by:
  `addProgressListener` in interface `TreeBuilder<T extends Tree>`

### removeProgressListener

public void removeProgressListener(ProgressListener listener)

Specified by:
  `removeProgressListener` in interface `TreeBuilder<T extends Tree>`

### fireSetProgress

public void fireSetProgress(double fractionCompleted)

### getBuilder

public static ClusteringTreeBuilder getBuilder(TreeBuilderFactory.Method method, DistanceMatrix distances)
A factory method to create a ClusteringTreeBuilder

Parameters:
  `method` - build method to use.
  `distances` - Pre computed pairwise distances.
Returns:
  A tree builder using method and distance matrix